> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/zec/instance/releaseinstances.md).

# ReleaseInstances

## 1. API Description

This API (ReleaseInstances) is used to release one or more elastic compute instances.

{% hint style="info" %}
**Notes**

* This is an asynchronous API. The request returns immediately after submission, but the operation is not yet complete. You can query the instance status by calling [`DescribeInstances`](/api-reference/compute/zec/instance/describeinstances.md). When the instance no longer appears in the query results, it has been fully destroyed. No operations can be performed on the instance during the release process.
* In most cases, instance resources are reclaimed immediately after release and cannot be recovered. For some accounts, released instances may first enter the `RECYCLED` (recycle bin) state and be retained for a period of time, during which you can call this API again to permanently delete them. Please proceed with caution.
* Batch operations are supported. The maximum number of instances per batch request is 100.
* When `dependResource` is set to `true` (the default), the elastic public IP (non-default IP), unmountable cloud disks, and non-primary network cards associated with the instance will be synchronizedly released; when `dependResource` is set to `false`, only the instance itself will be released, while the associated resources will be retained and continue to be charged.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                                                                                                      |
| -------------- | -------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| instanceIds    | Yes      | Array of String | <p>Instance ID(s).</p><p>To obtain the instance ID, you can call DescribeInstances and look for instanceId in the response. The maximum number of instances in each request is 100.</p>                                                          |
| dependResource | No       | Boolean         | <p>Whether to release associated resources synchronously when releasing an instance.</p><p>true: Synchronous release (default); false: Release only the instance itself, while retaining the associated resources.</p><p>Default value: true</p> |

## 3. Output Parameters

| Parameter Name | Type            | Description                                                                                                           |
| -------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| instanceIds    | Array of String | List of instance IDs that failed the operation.                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Release instances in batches.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ReleaseInstances
<Common Request Params>

Request:
{
  "instanceIds": [
    "instanceId1",
    "instanceId2"
  ]
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453"
  }
}
```

**2. Only the instance itself is released, while the associated resources (EIP, cloud disk, network card) remain intact.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ReleaseInstances
<Common Request Params>

Request：
{
  "instanceIds": [
    "instanceId1"
  ],
  "dependResource": false
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
